
//	Property Sheet for Microsoft Xbox 360 Wireless Controller

#pragma	once

#include	"page.h"
#include	"device.h"
#include	"report.h"

//----------------------------------------------------------------------------------------------
//	萔
//----------------------------------------------------------------------------------------------

#define	X360WCPS_MUTEX				L"x360wcps mutex"

#define	X360WCSAI_CLASS_NAME		L"x360wcsai class"
#define	X360WCSAI_WINDOW_NAME		L"x360wcsai window"

#define	WM_STATUS_AREA_ICON_NOTIFY	WM_USER + 1

#define	STATUS_AREA_ICON_ID			0
#define	UPDATE_SETTING				1

#define	POLLING_TIMER_ID			1
#define POLLING_INTERVAL			16

//----------------------------------------------------------------------------------------------
//	NX
//----------------------------------------------------------------------------------------------

class CControllerPage : public CPage
{

public:

	//	RXgN^
	CControllerPage( CSetting * );

	//	_CAO
	VOID wmInitDialog( HWND );
	//	R}h
	VOID wmCommand( HWND, WORD, WORD );
	//	ʒm
	VOID wmNotify( NMHDR * );
	//	^C}[
	VOID wmTimer( WPARAM );
	//	y[WύX̒ʒm
	VOID wmPageChanged();

	//	ݒ𔽉f
	VOID ApplySetting();

	//	ݒ̏ԂύX
	VOID ChangeSetting();
	//	݂̐ݒۑ
	VOID SaveSetting();
	//	݂̐ݒ폜
	VOID DeleteSetting();

	//	ݒ̕ύX𔽉f
	VOID ApplyChangedSetting();

	//	y[W
	VOID ClosePage();

	//	Rg[[̏Ԃ\
	VOID ShowControllerState();
	//	UeXg
	VOID TestForceFeedback( LONG );

private:

	//	~[ebNX
	HANDLE		Mutex;

	//	foCXɓKpĂZbeBO
	SETTING		DeviceSetting;

	//	foCX
	CDevice *	Device;
	//	|[g
	CReport *	Report;

	//	Rg[[̍Ō̏
	LAST_STATE	LastState;

protected:

};
