
//	Property Sheet for Microsoft Xbox 360 Wireless Controller

#pragma	once

#include	<windows.h>
#include	<commctrl.h>

#include	"setting.h"

//----------------------------------------------------------------------------------------------
//	萔
//----------------------------------------------------------------------------------------------

#define	WM_PAGE_CHANGED				WM_USER + 1
#define	WM_SETTING_LIST_CHANGED		WM_USER + 2

//----------------------------------------------------------------------------------------------
//	NX
//----------------------------------------------------------------------------------------------

class CPage
{

public:

	//	RXgN^
	CPage();

	//	_CAO
	virtual VOID wmInitDialog( HWND );
	//	R}h
	virtual VOID wmCommand( HWND, WORD, WORD );
	//	ʒm
	virtual VOID wmNotify( NMHDR * );
	//	^C}[
	virtual VOID wmTimer( WPARAM );
	//	XN[
	virtual VOID wmHScroll( HWND, WORD );
	//	y[WύX̒ʒm
	virtual VOID wmPageChanged();
	//	ݒύX̒ʒm
	virtual VOID wmSettingListChanged();

	//	ݒ𔽉f
	virtual VOID ApplySetting();

private:

protected:

	//	ݒ̕ύXʒm
	VOID SettingChanged();

	//	R{ {bNX
	VOID InitComboBox( WORD, WORD *, WORD );
	//	R{ {bNXԂݒ肷
	VOID SetComboBoxIndex( WORD, UCHAR );
	//	R{ {bNXԂ擾
	UCHAR GetComboBoxIndex( WORD );

	//	Xg {bNX
	VOID InitListBox( WORD, WORD *, WORD );
	//	Xg {bNX̏Ԃݒ肷
	VOID SetListBoxIndex( WORD, LONG );
	//	Xg {bNX̏Ԃ擾
	LONG GetListBoxIndex( WORD );

	//	`FbN {bNX̏Ԃݒ肷
	VOID SetCheckBoxState( WORD, BOOLEAN );
	//	`FbN {bNX̏Ԃ擾
	BOOLEAN GetCheckBoxState( WORD );

	//	gbN o[
	VOID InitTrackBar( WORD, UCHAR, UCHAR, UCHAR, UCHAR );
	//	gbN o[̈ʒuݒ肷
	VOID SetTrackBarPos( WORD, UCHAR );
	//	gbN o[̈ʒu擾
	UCHAR GetTrackBarPos( WORD );
	//	gbN o[͈̔͂ݒ肷
	VOID SetTrackBarRange( WORD, UCHAR, UCHAR );
	//	gbN o[͈̔͂擾
	VOID GetTrackBarRange( WORD, UCHAR *, UCHAR * );
	//	gbN o[̑Is
	VOID SelectTrackBar( HWND, WORD, BOOL * );

	//	bZ[W {bNX\
	LONG ShowMessageBox( ULONG, ULONG, WCHAR *, ULONG );

	//	EBhEɐlݒ肷
	VOID SetIntegerText( WORD, LONG );
	//	EBhEɃ{^ԍݒ肷
	VOID SetButtonNumberText( WORD, ULONG );

	//	Rg[̏Ԃʂ̋@\擾
	UCHAR GetWayUsageByControlIndex( WORD );
	//	ʂ̋@\Rg[̏Ԃ擾
	UCHAR GetControlIndexByWayUsage( UCHAR );

	//	Rg[̗LA؂ւ
	VOID EnableControl( WORD, BOOL );
	//	͈͓̃Rg[̗LA؂ւ
	VOID EnableControls( WORD, WORD, BOOL );

	//	EBhE nh
	HWND		Wnd;
	//	ݒ
	CSetting *	Setting;

	//	݂̃Rg[[̐ݒ
	SETTING *	CurrentSetting;

};

//----------------------------------------------------------------------------------------------
//	֐
//----------------------------------------------------------------------------------------------

INT_PTR CALLBACK PageProc( HWND, UINT, WPARAM, LPARAM );

