
//	Property Sheet for Microsoft Xbox 360 Wireless Controller

//----------------------------------------------------------------------------------------------
//	X^eBbN
//----------------------------------------------------------------------------------------------

#define	IDC_STATIC								-1

//----------------------------------------------------------------------------------------------
//	_CAO
//----------------------------------------------------------------------------------------------

#define	IDD_CONTROLLER							1000
#define	IDC_SETTING								1001
#define	IDC_SETTING_SAVE						1002
#define	IDC_SETTING_DELETE						1003
#define	IDC_X_AXIS								1004
#define	IDC_Y_AXIS								1005
#define	IDC_Z_AXIS								1006
#define	IDC_X_ROTATION							1007
#define	IDC_Y_ROTATION							1008
#define	IDC_Z_ROTATION							1009
#define	IDC_HAT_SWITCH1							1010
#define	IDC_HAT_SWITCH2							1011
#define	IDC_HAT_SWITCH3							1012
#define	IDC_HAT_SWITCH4							1013
#define	IDC_SLIDER1								1014
#define	IDC_SLIDER2								1015
#define	IDC_BUTTON								1016
#define	IDC_FORCE_FEEDBACK						1017
#define	IDD_STICK								1100
#define	IDC_LEFT_STICK_USAGE					1101
#define	IDC_LEFT_STICK_REVERSE_Y				1102
#define	IDC_RIGHT_STICK_USAGE					1103
#define	IDC_RIGHT_STICK_REVERSE_Y				1104
#define	IDC_STICK_THRESHOLD						1105
#define	IDC_STICK_HAT_SWITCH_THRESHOLD			1106
#define	IDD_DIRECTIONAL_PAD						1200
#define	IDC_DIRECTIONAL_PAD_USAGE				1201
#define	IDC_DIRECTIONAL_PAD_REVERSE_Y			1202
#define	IDC_STATIC_301							1203
#define	IDC_STATIC_302							1204
#define	IDC_DIRECTIONAL_PAD_UP_USAGE			1205
#define	IDC_DIRECTIONAL_PAD_UP_RAPID_FIRE		1206
#define	IDC_STATIC_303							1207
#define	IDC_STATIC_304							1208
#define	IDC_DIRECTIONAL_PAD_DOWN_USAGE			1209
#define	IDC_DIRECTIONAL_PAD_DOWN_RAPID_FIRE		1210
#define	IDC_STATIC_305							1211
#define	IDC_STATIC_306							1212
#define	IDC_DIRECTIONAL_PAD_LEFT_USAGE			1213
#define	IDC_DIRECTIONAL_PAD_LEFT_RAPID_FIRE		1214
#define	IDC_STATIC_307							1215
#define	IDC_STATIC_308							1216
#define	IDC_DIRECTIONAL_PAD_RIGHT_USAGE			1217
#define	IDC_DIRECTIONAL_PAD_RIGHT_RAPID_FIRE	1218
#define	IDD_TRIGGER								1300
#define	IDC_LEFT_TRIGGER_USAGE					1301
#define	IDC_LEFT_TRIGGER_RAPID_FIRE				1302
#define	IDC_RIGHT_TRIGGER_USAGE					1303
#define	IDC_RIGHT_TRIGGER_RAPID_FIRE			1304
#define	IDC_TRIGGER_THRESHOLD					1305
#define	IDC_TRIGGER_BUTTON_THRESHOLD			1306
#define	IDD_BUTTON								1400
#define	IDC_BUTTON_LIST							1401
#define	IDC_BUTTON_USAGE						1402
#define	IDC_BUTTON_RAPID_FIRE					1403
#define	IDC_STATIC_501							1404
#define	IDC_STATIC_502							1405
#define	IDC_BUTTON_RAPID_FIRE_SPEED				1406
#define	IDC_STATIC_503							1407
#define	IDC_RING_LIGHT_PATTERN					1408
#define	IDD_ACTUATOR							1500
#define	IDC_ACTUATOR							1501
#define	IDC_STATIC_601							1502
#define	IDC_STATIC_602							1503
#define	IDC_STATIC_603							1504
#define	IDC_STATIC_604							1505
#define	IDC_LEFT_ACTUATOR_LEVEL					1506
#define	IDC_STATIC_605							1507
#define	IDC_STATIC_606							1508
#define	IDC_STATIC_607							1509
#define	IDC_RIGHT_ACTUATOR_LEVEL				1510
#define	IDC_STATIC_608							1511
#define	IDC_STATIC_609							1512
#define	IDC_STATIC_610							1513
#define	IDC_STATIC_611							1514
#define	IDC_STATIC_612							1515
#define	IDC_ACTUATOR_THRESHOLD					1516
#define	IDC_STATIC_613							1517
#define	IDD_ADVANCED							1600
#define	IDC_STICK_DEAD_ZONE_TYPE_BOX			1601
#define	IDC_STICK_DEAD_ZONE_TYPE_CIRCLE			1602
#define	IDC_SLIDER_LIST							1603
#define	IDC_SLIDE_SLIDER_VALUE					1604
#define	IDC_SLIDE_SLIDER_CENTER_VALUE			1605
#define	IDC_REVERSE_SLIDER_VALUE				1606
#define	IDC_LIMITATION_MODE						1607
#define	IDC_DEVICES_ARE_POLLED					1608
#define	IDD_SAVE_DIALOG							1700
#define	IDC_SETTING_NAME						1701

//----------------------------------------------------------------------------------------------
//	ACR
//----------------------------------------------------------------------------------------------

#define	IDI_ICON								2000

//----------------------------------------------------------------------------------------------
//	e[u
//----------------------------------------------------------------------------------------------

#define	IDS_SHEET_CAPTION						3000
#define	IDS_DEFAULT_SETTING						3100
#define	IDS_MODIFIED							3101
#define	IDS_NONE								3102
#define	IDS_X_AXIS_Y_AXIS						3200
#define	IDS_Y_AXIS_X_AXIS						3201
#define	IDS_X_ROTATION_Y_ROTATION				3202
#define	IDS_Y_ROTATION_X_ROTATION				3203
#define	IDS_Z_AXIS_ROTATION						3204
#define	IDS_Z_AXIS_SLIDER1						3205
#define	IDS_Z_AXIS_SLIDER2						3206
#define	IDS_Z_ROTATION_AXIS						3207
#define	IDS_Z_ROTATION_SLIDER1					3208
#define	IDS_Z_ROTATION_SLIDER2					3209
#define	IDS_SLIDER1_Z_AXIS						3210
#define	IDS_SLIDER1_Z_ROTATION					3211
#define	IDS_SLIDER1_SLIDER2						3212
#define	IDS_SLIDER2_Z_AXIS						3213
#define	IDS_SLIDER2_Z_ROTATION					3214
#define	IDS_SLIDER2_SLIDER1						3215
#define	IDS_HAT_SWITCH1							3216
#define	IDS_HAT_SWITCH2							3217
#define	IDS_HAT_SWITCH3							3218
#define	IDS_HAT_SWITCH4							3219
#define	IDS_4WAY_BUTTON							3220
#define	IDS_X_AXIS_PLUS							3300
#define	IDS_X_AXIS_MINUS						3301
#define	IDS_Y_AXIS_PLUS							3302
#define	IDS_Y_AXIS_MINUS						3303
#define	IDS_X_ROTATION_PLUS						3304
#define	IDS_X_ROTATION_MINUS					3305
#define	IDS_Y_ROTATION_PLUS						3306
#define	IDS_Y_ROTATION_MINUS					3307
#define	IDS_Z_AXIS_PLUS							3308
#define	IDS_Z_AXIS_MINUS						3309
#define	IDS_Z_ROTATION_PLUS						3310
#define	IDS_Z_ROTATION_MINUS					3311
#define	IDS_SLIDER1_PLUS						3312
#define	IDS_SLIDER1_MINUS						3313
#define	IDS_SLIDER2_PLUS						3314
#define	IDS_SLIDER2_MINUS						3315
#define	IDS_BUTTON1								3316
#define	IDS_BUTTON2								3317
#define	IDS_BUTTON3								3318
#define	IDS_BUTTON4								3319
#define	IDS_BUTTON5								3320
#define	IDS_BUTTON6								3321
#define	IDS_BUTTON7								3322
#define	IDS_BUTTON8								3323
#define	IDS_BUTTON9								3324
#define	IDS_BUTTON10							3325
#define	IDS_BUTTON11							3326
#define	IDS_BUTTON12							3327
#define	IDS_BUTTON13							3328
#define	IDS_BUTTON14							3329
#define	IDS_BUTTON15							3330
#define	IDS_BUTTON16							3331
#define	IDS_BUTTON17							3332
#define	IDS_BUTTON18							3333
#define	IDS_BUTTON19							3334
#define	IDS_BUTTON20							3335
#define	IDS_BUTTON21							3336
#define	IDS_BUTTON22							3337
#define	IDS_BUTTON23							3338
#define	IDS_BUTTON24							3339
#define	IDS_BUTTON25							3340
#define	IDS_BUTTON26							3341
#define	IDS_BUTTON27							3342
#define	IDS_BUTTON28							3343
#define	IDS_BUTTON29							3344
#define	IDS_BUTTON30							3345
#define	IDS_BUTTON31							3346
#define	IDS_BUTTON32							3347
#define	IDS_A_BUTTON							3400
#define	IDS_B_BUTTON							3401
#define	IDS_X_BUTTON							3402
#define	IDS_Y_BUTTON							3403
#define	IDS_LB_BUTTON							3404
#define	IDS_RB_BUTTON							3405
#define	IDS_START_BUTTON						3406
#define	IDS_BACK_BUTTON							3407
#define	IDS_LEFT_STICK_BUTTON					3408
#define	IDS_RIGHT_STICK_BUTTON					3409
#define	IDS_XBOX_GUIDE_BUTTON					3410
#define	IDS_RING_LIGHT_0						3500
#define	IDS_RING_LIGHT_1						3501
#define	IDS_RING_LIGHT_2						3502
#define	IDS_RING_LIGHT_3						3503
#define	IDS_RING_LIGHT_4						3504
#define	IDS_RING_LIGHT_5						3505
#define	IDS_RING_LIGHT_6						3506
#define	IDS_RING_LIGHT_7						3507
#define	IDS_RING_LIGHT_8						3508
#define	IDS_RING_LIGHT_9						3509
#define	IDS_RING_LIGHT_10						3510
#define	IDS_RING_LIGHT_11						3511
#define	IDS_RING_LIGHT_12						3512
#define	IDS_RING_LIGHT_13						3513
#define	IDS_RING_LIGHT_14						3514
#define	IDS_RING_LIGHT_15						3515
#define	IDS_Z_AXIS								3600
#define	IDS_Z_ROTATION							3601
#define	IDS_SLIDER1								3602
#define	IDS_SLIDER2								3603
#define	IDS_LIMITATION_MODE_0					3700
#define	IDS_LIMITATION_MODE_1					3701
#define	IDS_LIMITATION_MODE_2					3702
#define	IDS_LIMITATION_MODE_3					3703
#define	IDS_SAVE_TITLE							3801
#define	IDS_SAVE_MESSAGE						3802
#define	IDS_WARNING_TITLE						3803
#define	IDS_WARNING_MESSAGE						3804
#define	IDS_REPLACE_TITLE						3805
#define	IDS_REPLACE_MESSAGE						3806
#define	IDS_DELETE_TITLE						3807
#define	IDS_DELETE_MESSAGE						3808
#define	IDS_RESTART_TITLE						3809
#define	IDS_RESTART_MESSAGE						3810
